from typing import Any

LOGGER: Any
CREDENTIALS_DIR: Any
CREDENTIALS_PATH: Any
DEVICE_CONFIG_PATH: Any
DEV_HOST_CONFIG_PATH: Any
SYSTEM_ID_OPTIONS: Any
DAYS_TO_SECONDS: int
DEVICE: bool
DEVICE_MODE: Any
DEV_HOST: bool

class ErrorCode:
    def __init__(self) -> None: ...
    @property
    def list(self): ...
    def log(self, code: Any) -> None: ...

ERROR_CODE: Any

def reset_errors() -> None: ...
def log_error(error_code: Any) -> None: ...

ERROR_NO_CREDENTIALS_FILE: int
ERROR_DEVICE_SYSTEM_ID: int
ERROR_DEVICE_ID: int
ERROR_NO_DEVICE_TOKENS: int
ERROR_DEVICE_TOKEN_REFRESH_FAILURE_EXCEPTION: int
ERROR_DEVICE_TOKEN_REFRESH_FAILURE_STATUS: int
ERROR_DEVICE_TOKEN_REFRESH_FAILURE_FORMAT: int
ERROR_NO_DEV_HOST_TOKENS: int
ERROR_DEV_HOST_SYSTEM_ID: int
ERROR_DEV_HOST_TOKEN_REFRESH_FAILURE_EXCEPTION: int
ERROR_DEV_HOST_TOKEN_REFRESH_FAILURE_FORMAT: int
ERROR_NO_INTERNET_CONNECTION: int
ERROR_TOKEN_HEADERS_FAILURE: int
ERROR_NO_PUBLIC_KEY: int
ERROR_TOKEN_SIGNATURE_FAILED: int
ERROR_TOKEN_EXPIRED: int
ERROR_NO_ID_TOKEN_OR_KEYS: int
USER_POOL_CONFIG: Any
REGION: str
REFRESH_DEVICE_ENDPOINT: Any

class JsonFile:
    def __init__(self, path: Any) -> None: ...
    @property
    def contents(self): ...
    def exists(self): ...
    def load(self): ...

class CredentialsFile(JsonFile):
    def __init__(self) -> None: ...
    @property
    def device_id(self): ...
    @property
    def device_refresh_token(self): ...
    @property
    def device_id_token(self): ...
    def get_dev_host_refresh_token(self, user_pool_client_id: Any): ...
    def get_dev_host_id_token(self, user_pool_client_id: Any): ...
    def update(self, data_to_update: Any): ...

def validate_system_id(system_id: Any): ...

class DeviceConfigFile(JsonFile):
    def __init__(self) -> None: ...
    @property
    def system_id(self): ...

class DevHostConfigFile(JsonFile):
    def __init__(self) -> None: ...
    @property
    def system_id(self): ...

class Token:
    token: Any = ...
    def __init__(self, token: Any, keys: Any) -> None: ...
    def decode(self): ...
    def validate_expiry(self): ...
    def get_audience(self, is_id_token: bool = ...): ...
    @property
    def claims(self): ...

class TokenGroup:
    def __init__(self, config: Any, system_id: Any, refresh_token: Any, undecoded_id_token: Any) -> None: ...
    def exists(self): ...
    def decode(self): ...
    def validate(self): ...

class DeviceTokens(TokenGroup):
    mode: str = ...
    def __init__(self, token_file: Any, system_id: Any, device_id: Any) -> None: ...
    def decode(self): ...
    def refresh(self): ...

class DevelopmentHostTokens(TokenGroup):
    def __init__(self, token_file: Any, system_id: Any) -> None: ...
    def refresh(self): ...

def validate_device_tokens(token_file: Any): ...
def validate_development_host_tokens(token_file: Any): ...
def validate_credentials() -> None: ...
